SystemOrganization addCategory: #TinyBlog!
SystemOrganization addCategory: #'TinyBlog-Components'!
SystemOrganization addCategory: #'TinyBlog-Core'!
SystemOrganization addCategory: #'TinyBlog-Core-Tests'!
SystemOrganization addCategory: #'TinyBlog-Manifest'!
SystemOrganization addCategory: #'TinyBlog-Teapot'!
SystemOrganization addCategory: #'TinyBlog-Teapot-Tests'!

PackageManifest subclass: #ManifestTinyBlog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Manifest'!

!ManifestTinyBlog commentStamp: '<historical>' prior: 0!
I store metadata for this package. These meta data are used by other tools such as the SmalllintManifestChecker and the critics Browser!

!ManifestTinyBlog class methodsFor: 'code-critics' stamp: 'PeterPesch 6/24/2020 14:24'!
ruleGRUsesCurlyBraceArraysRuleV1FalsePositive
	^ #(#(#(#RGMethodDefinition #(#TBXTeapotWebApp #initialize #false)) #'2020-06-24T14:24:30.614032+02:00') )! !

!ManifestTinyBlog class methodsFor: 'code-critics' stamp: 'PeterPesch 7/3/2020 10:51'!
ruleReTestClassNotInPackageWithTestEndingNameV1FalsePositive
	^ #(#(#(#RGClassDefinition #(#TBXTeapotWebAppTest)) #'2020-06-24T15:07:42.718032+02:00') #(#(#RGPackageDefinition #(#TinyBlog)) #'2020-07-03T10:51:00.45014+02:00') )! !

TBSMagritteReport subclass: #TBXPostsReport
	instanceVariableNames: 'report blog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Components'!

!TBXPostsReport commentStamp: 'PeterPesch 7/3/2020 14:45' prior: 0!
I am an admin report which contains all posts.!

!TBXPostsReport class methodsFor: 'acccessing' stamp: 'PeterPesch 7/3/2020 14:49'!
filteredDescriptionsFrom: aBlogPost
	^ aBlogPost magritteDescription select: [ :each |
			#(title category date) includes: each accessor selector ]! !

!TBXPostsReport class methodsFor: 'instance creation' stamp: 'PeterPesch 7/3/2020 15:03'!
from: aBlog
	| report blogPosts |
	blogPosts := aBlog allBlogPosts.
	report := self rows: blogPosts description:
		(self filteredDescriptionsFrom: blogPosts anyOne).
	report blog: aBlog.
	report addColumn: (MACommandColumn new
		addCommandOn: report selector: #viewPost: text: 'View';
		yourself;
		addCommandOn: report selector: #editPost: text: 'Edit'; yourself;
		addCommandOn: report selector: #deletePost: text: 'Delete';
		yourself).
	^ report! !

!TBXPostsReport methodsFor: 'adding' stamp: 'PeterPesch 7/3/2020 15:36'!
addPost
	| post |
	post := self call: (self renderAddPostForm: TBXPost new).
	post ifNotNil: [ 
			blog writeBlogPost: post.
			self refreshReport ]! !

!TBXPostsReport methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 15:00'!
blog
	^ blog! !

!TBXPostsReport methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 15:01'!
blog: aTBXBlog
	blog := aTBXBlog! !

!TBXPostsReport methodsFor: 'actions' stamp: 'PeterPesch 7/3/2020 15:37'!
deletePost: aPost
	(self confirm: 'Do you want remove this post ?')
		ifFalse: [ ^ self ].
	blog removeBlogPost: aPost.
	self refreshReport! !

!TBXPostsReport methodsFor: 'actions' stamp: 'PeterPesch 7/3/2020 15:17'!
editPost: aPost
	| post |
	post := self call: (self renderEditPostForm: aPost).
	post ifNotNil: [ blog save ]! !

!TBXPostsReport methodsFor: 'actions' stamp: 'PeterPesch 7/3/2020 15:36'!
refreshReport
	self rows: blog allBlogPosts.
	self refresh.! !

!TBXPostsReport methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 15:16'!
renderAddPostForm: aPost
	^ aPost asComponent
		addDecoration: (TBSMagritteFormDecoration buttons: { #save -> 'Add post' . #cancel -> 'Cancel'});
		yourself! !

!TBXPostsReport methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 15:04'!
renderContentOn: html
	html tbsGlyphIcon perform: #iconPencil.
	html anchor
		callback: [ self addPost ];
		with: 'Add post'.
	super renderContentOn: html! !

!TBXPostsReport methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 15:16'!
renderEditPostForm: aPost
	^ aPost asComponent
		addDecoration: (TBSMagritteFormDecoration buttons: { #save -> 'Save post' . #cancel -> 'Cancel'});
		yourself! !

!TBXPostsReport methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 15:21'!
renderViewPostForm: aPost
	^ aPost asComponent
		addDecoration: (TBSMagritteFormDecoration buttons: { #cancel -> 'Back' });
		yourself! !

!TBXPostsReport methodsFor: 'actions' stamp: 'PeterPesch 7/3/2020 15:20'!
viewPost: aPost
	self call: (self renderViewPostForm: aPost)! !

TestCase subclass: #TBXBlogTest
	instanceVariableNames: 'blog post first originalSize testSize invisiblePost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Core-Tests'!

!TBXBlogTest methodsFor: 'running' stamp: 'PeterPesch 6/29/2020 10:45'!
setUp
	"Initialize the Fixture"
	super setUp.

	blog := TBXBlog current.
	originalSize := blog size.
	first := TBXPost title: 'A title' text: 'A text' category: 'First Category'.
	testSize := blog size.
	invisiblePost := (TBXPost title: 'Invisible Post' text: 'text' category: 'First Category') notVisible.
	post := (TBXPost title: 'Another title' text: 'Another text' category: 'Second Category') beVisible.
! !

!TBXBlogTest methodsFor: 'running' stamp: 'PeterPesch 7/2/2020 16:56'!
tearDown
	[ blog size > originalSize ] whileTrue: [ blog removeLast ].
	super tearDown! !

!TBXBlogTest methodsFor: 'tests' stamp: 'PeterPesch 6/29/2020 10:25'!
testAddBlogPost
			
	| newSize |
	blog writeBlogPost: post.
	newSize := blog size.
	blog removeLast.
	self assert: newSize equals: (testSize + 1).
! !

!TBXBlogTest methodsFor: 'tests' stamp: 'PeterPesch 6/29/2020 10:31'!
testAllBlogPosts
	| newSize |
	blog writeBlogPost: post.
	newSize := blog allBlogPosts size.
	blog removeLast.
	self assert: newSize equals: (testSize + 1).
! !

!TBXBlogTest methodsFor: 'tests' stamp: 'PeterPesch 6/29/2020 10:32'!
testAllBlogPostsFromCategory
	| before after |
	before := (blog allBlogPostsFromCategory: 'First Category') size.
	blog writeBlogPost: first.
	after := (blog allBlogPostsFromCategory: 'First Category') size.
	blog removeLast.
	self assert: after equals: before + 1
! !

!TBXBlogTest methodsFor: 'tests' stamp: 'PeterPesch 7/2/2020 17:11'!
testAllCategories
	| before after newCategory newPost |
	before := blog allCategories size.
	newCategory := (blog allCategories asOrderedCollection reverse at: 1) , '_ZZZ'.
	newPost := TBXPost title: 'My Title' text: 'My text.' category: newCategory.
	blog writeBlogPost: newPost.
	after := blog allCategories size.
	blog removeLast.
	self assert: after equals: before + 1! !

!TBXBlogTest methodsFor: 'tests' stamp: 'PeterPesch 6/29/2020 10:46'!
testAllVisibleBlogPosts
	| before inbetween after |
	before := blog allVisibleBlogPosts size.
	blog writeBlogPost: invisiblePost .
	inbetween := blog allVisibleBlogPosts size.
	blog writeBlogPost: post.
	after := blog allVisibleBlogPosts size.
	blog removeLast.
	blog removeLast.
	self assert: inbetween equals: before.
	self assert: after equals: before + 1
! !

!TBXBlogTest methodsFor: 'tests' stamp: 'PeterPesch 6/29/2020 10:50'!
testAllVisibleBlogPostsFromCategory
	| before1 after1 before2 after2 |
	before1 := (blog allVisibleBlogPostsFromCategory: 'First Category') size.
	before2 := (blog allVisibleBlogPostsFromCategory: 'Second Category') size.
	blog writeBlogPost: post.
	after1 := (blog allVisibleBlogPostsFromCategory: 'First Category') size.
	after2 := (blog allVisibleBlogPostsFromCategory: 'Second Category') size.
	blog removeLast.
	self assert: after1 equals: before1.
	self assert: after2 equals: before2 + 1
! !

!TBXBlogTest methodsFor: 'tests' stamp: 'PeterPesch 7/3/2020 15:32'!
testRemoveBlogPost
			
	| newPost newSize endSize |
	newPost := TBXPost title: 'New' text: 'A new text' category: 'New Category'.
	blog writeBlogPost: newPost.
	newSize := blog size.
	blog removeBlogPost: newPost.
	endSize := blog size.
	self assert: endSize equals: (newSize - 1).
! !

!TBXBlogTest methodsFor: 'tests' stamp: 'PeterPesch 6/29/2020 11:01'!
testUnclassifiedBlogPosts
	| before after |
	before := (blog allBlogPosts select: [ :p | p isUnclassified ]) size.
	blog writeBlogPost: ((TBXPost
   		 title: 'The sad story of unclassified blog posts'
       text: 'So sad that I can read this.') visible: true).
	after := (blog allBlogPosts select: [ :p | p isUnclassified ]) size.
	blog removeLast.
	self assert: after equals: before + 1! !

TestCase subclass: #TBXPostTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Core-Tests'!

!TBXPostTest methodsFor: 'tests' stamp: 'PeterPesch 7/2/2020 17:37'!
dontTestTitleRequired
	"Check that title is required."
	self should: [ TBXPost new ] raise: Error.
	self should: [ TBXPost title: '' text: 'My text.' ] raise: Error.
	self should: [ TBXPost title: nil text: 'My text.' ] raise: Error.
	self shouldnt: [ TBXPost title: 'My title' text: 'My text.' ] raise: Error.
	self should: [ TBXPost title: '' text: 'My text.' category: 'My category' ] raise: Error.
	self should: [ TBXPost title: nil text: 'My text.' category: 'My category' ] raise: Error.
	self shouldnt: [ TBXPost title: 'My title' text: 'My text.' category: 'My category' ] raise: Error.
! !

!TBXPostTest methodsFor: 'tests' stamp: 'PeterPesch 6/10/2020 17:02'!
testPostIsCreatedCorrectly
	"Check whether a new blog post created correctly"

	| post |
	post := TBXPost
		title: 'Welcome to my blog'
		text: 'TinyBlog is a small blog engine made with Pharo.'
		category: 'TinyBlog'.
	self assert: post title equals: 'Welcome to my blog'.
	self assert: post text equals: 'TinyBlog is a small blog engine made with Pharo.'.
	self assert: post category equals: 'TinyBlog'.
! !

!TBXPostTest methodsFor: 'tests' stamp: 'PeterPesch 6/10/2020 17:17'!
testWithoutCategoryIsUnclassified
	"Check whether a new blog post without category is Unclassified"

	| post |
	post := TBXPost
		title: 'Welcome to my blog'
		text: 'TinyBlog is a small blog engine made with Pharo.'.
	self assert: post title equals: 'Welcome to my blog'.
	self assert: post isUnclassified.
	self deny: post isVisible.
! !

TestCase subclass: #TBXTeapotWebAppTest
	instanceVariableNames: 'webAddress wasRunning wasEmpty'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Teapot-Tests'!

!TBXTeapotWebAppTest methodsFor: 'running' stamp: 'PeterPesch 7/5/2020 09:25'!
setUp
    "Hooks that subclasses may override to define the fixture of test."
    | webApp blog |
    super setUp.
    webApp := TBXTeapotWebApp singleton.
    webAddress :=
        'http://localhost:',
        (webApp instVarNamed: 'teapot') server port greaseString.
    wasRunning := webApp isRunning.
    wasRunning 
        ifFalse: [ webApp start ].

    blog := TBXBlog current.
    wasEmpty := blog isEmpty.
    wasEmpty
        ifTrue: [ blog createDemoPosts ]! !

!TBXTeapotWebAppTest methodsFor: 'running' stamp: 'PeterPesch 7/4/2020 20:11'!
tearDown
    | webApp blog |
    webApp := TBXTeapotWebApp singleton.
    wasRunning ifTrue: [ webApp stop ].
    blog := TBXBlog current.
    wasEmpty ifTrue: [ blog removeLast: 5 ].
    super tearDown! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 7/5/2020 09:20'!
testAllPosts
	| result tree node webAppSize blog visibleBlogSize |
	blog := TBXBlog current.
	visibleBlogSize := blog allVisibleBlogPosts size.
	result := ZnEasy get: webAddress.
	tree := (XMLDOMParser on: result entity string) parseDocument.
	node := (tree allElements: 'ul') at: 1.
	webAppSize := node nodes size.
	self assert: webAppSize equals: visibleBlogSize
! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 7/4/2020 20:00'!
testErrorPage
	| result tree node size |
	size := TBXBlog current size.
	result := ZnEasy get: (webAddress , '/post/', (size + 1) greaseString).
	tree := (XMLDOMParser on: result entity string) parseDocument.
	node := (tree allElements: 'p') at: 1.
	node := node nodes at: 1.
	self assert: node string equals: 'Oops, an error occurred'! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 7/4/2020 19:55'!
testHomepage
	| result tree node |
	result := ZnEasy get: webAddress.
	tree := (XMLDOMParser on: result entity string) parseDocument.
	node := (tree allElements: 'h1') at: 1.
	node := node nodes at: 1.
	self assert: node string equals: 'TinyBlog Web App'! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 7/5/2020 18:39'!
testIsRunning
	self assert: TBXTeapotWebApp singleton isRunning.

	
	! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 7/5/2020 09:12'!
testLinksToPosts
	| result tree node title link dict blog postNr |
	blog := TBXBlog current.
	postNr := blog size atRandom.
	result := ZnEasy get: (webAddress).
	tree := (XMLDOMParser on: result entity string) parseDocument.
	node := (tree allElements: 'li') at: postNr.
	node := (node allElements: 'a') at: 1.

	dict := node attributes.
	link := dict at: (dict orderedKeys at: 1).
	title := (node nodes at: 1) string.

	result := ZnEasy get: (webAddress , link).	
	tree := (XMLDOMParser on: result entity string) parseDocument.
	node := (tree allElements: 'h1') at: 1.
	node := node nodes at: 1.
	self assert: node string equals: title! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 7/5/2020 08:46'!
testPageForPostNumber
	| result tree node firstPost |
	result := ZnEasy get: (webAddress , '/post/1').
	tree := (XMLDOMParser on: result entity string) parseDocument.
	node := (tree allElements: 'h1') at: 1.
	node := node nodes at: 1.
	firstPost := TBXBlog current allBlogPosts at: 1.
	self assert: node string equals: firstPost title ! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 7/5/2020 18:28'!
testRenderPageFooterOn
| result tree node1 node2 |
    TBXTeapotWebApp stop.
    TBXTeapotWebApp start.
    result := (ZnEasy get: 'http://localhost:8081/').
    tree := (XMLDOMParser on: result entity string) parseDocument.
    node1 := tree nodes at: 1.
    self assert: node1 name equals: 'html'.
    node2 := node1 nodes at: 1.
    self assert: node2 name equals: 'body'
! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 7/5/2020 18:28'!
testRenderPageHeaderOn
| result tree node1 node2 |
    TBXTeapotWebApp stop.
    TBXTeapotWebApp start.
    result := (ZnEasy get: 'http://localhost:8081/').
    tree := (XMLDOMParser on: result entity string) parseDocument.
    node1 := tree nodes at: 1.
    self assert: node1 name equals: 'html'.
    node2 := node1 nodes at: 1.
    self assert: node2 name equals: 'body'
! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 7/5/2020 18:07'!
testSingleton 
	| twaSingleton twaServer |
	twaSingleton := TBXTeapotWebApp singleton.
	twaServer := TBXTeapotWebApp classVarNamed: 'Server'.
	self assert: twaSingleton equals: twaServer ! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 6/23/2020 16:52'!
testStart
    TBXTeapotWebApp stop.
    TBXTeapotWebApp start.
    self shouldnt: (ZnEasy get: webAddress) raise: Error.! !

!TBXTeapotWebAppTest methodsFor: 'tests' stamp: 'PeterPesch 6/24/2020 12:30'!
testStop
    | timeOut |
    TBXTeapotWebApp start.
    TBXTeapotWebApp stop.
    timeOut := false.
    [ ZnEasy get: webAddress ] on: ConnectionTimedOut do: [ :excepion | timeOut := true ].
    self assert: timeOut.! !

WAComponent subclass: #TBXApplicationRootComponent
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Components'!

!TBXApplicationRootComponent commentStamp: 'PeterPesch 7/3/2020 11:05' prior: 0!
I am the entry point of this web application.
!

!TBXApplicationRootComponent class methodsFor: 'testing' stamp: 'PeterPesch 6/29/2020 11:37'!
canBeRoot
	^ true! !

!TBXApplicationRootComponent class methodsFor: 'class initialization' stamp: 'PeterPesch 7/3/2020 16:20'!
initialize
    "self initialize"
    (WAAdmin register: self asApplicationAt: 'TinyBlog')
        preferenceAt: #sessionClass put: TBXSession;
        addLibrary: JQDeploymentLibrary;
        addLibrary: JQUiDeploymentLibrary;
        addLibrary: TBSDeploymentLibrary
! !

TBXApplicationRootComponent initialize!

!TBXApplicationRootComponent methodsFor: 'hooks' stamp: 'PeterPesch 6/29/2020 12:09'!
children
	^ { main }! !

!TBXApplicationRootComponent methodsFor: 'initialization' stamp: 'PeterPesch 6/29/2020 12:17'!
initialize
	super initialize.
	main := TBXPostsListComponent new.! !

!TBXApplicationRootComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:18'!
main: aComponent
	main := aComponent! !

!TBXApplicationRootComponent methodsFor: 'rendering' stamp: 'PeterPesch 6/29/2020 12:08'!
renderContentOn: html
	html render: main! !

!TBXApplicationRootComponent methodsFor: 'updating' stamp: 'PeterPesch 6/29/2020 11:40'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot beHtml5.
	anHtmlRoot title: 'TinyBlog'.! !

WAComponent subclass: #TBXAuthentificationComponent
	instanceVariableNames: 'password account component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Components'!

!TBXAuthentificationComponent commentStamp: 'PeterPesch 7/3/2020 11:04' prior: 0!
I am a component which manages a modal dialog box asking for a login and password.!

!TBXAuthentificationComponent class methodsFor: 'instance creation' stamp: 'PeterPesch 7/3/2020 11:13'!
from: aComponent
	^ self new component: aComponent! !

!TBXAuthentificationComponent methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 11:11'!
account
	^ account! !

!TBXAuthentificationComponent methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 11:11'!
account: anObject
	^ account := anObject! !

!TBXAuthentificationComponent methodsFor: 'services' stamp: 'PeterPesch 7/3/2020 13:51'!
alert: aMessage
	"TO DO: Do nothing."
	"No intended action has been suggested, so we don't know the meaning of this message."
	Transcript show: aMessage; cr
! !

!TBXAuthentificationComponent methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 11:12'!
component
	^ component! !

!TBXAuthentificationComponent methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 11:12'!
component: anObject
	component := anObject! !

!TBXAuthentificationComponent methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 11:11'!
password
	^ password! !

!TBXAuthentificationComponent methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 11:12'!
password: anObject
	^ password := anObject! !

!TBXAuthentificationComponent methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 14:11'!
renderButtonsOn: html
    html tbsSubmitButton
        attributeAt: 'type' asSymbol put: 'button';
        value: 'Cancel'.
    html tbsSubmitButton
        bePrimary;
        callback: [ self validate ];
        value: 'SignIn'.! !

!TBXAuthentificationComponent methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 14:14'!
renderContentOn: html
    html tbsModal id: 'myAuthDialog'; with: [
        html tbsModalDialog: [
            html tbsModalContent: [
                html tbsModalHeader: [
                    html tbsModalCloseIcon.
                    html tbsModalTitle level: 4; with: 'Authentification' ].
                html tbsModalBody: [ 
                    html form: [ 
                        self renderInputAccountOn: html.
                        html break.
                        self renderInputPasswordOn: html.
                        html break.
                        html break.
                        html tbsModalFooter: [ self renderButtonsOn: html ] ] ] ] ] ]
! !

!TBXAuthentificationComponent methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 11:39'!
renderInputAccountOn: html
    html text: 'Account:'.
    html break.
    html textInput
        callback: [ :value | account := value ];
        value: account.! !

!TBXAuthentificationComponent methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 11:39'!
renderInputPasswordOn: html
    html text: 'Password:'.
    html break.
    html passwordInput
        callback: [ :value | password := value ];
        value: password.! !

!TBXAuthentificationComponent methodsFor: 'authentication' stamp: 'PeterPesch 7/3/2020 16:15'!
validate
	(self account = 'admin' and: [ self password = 'password' ])
		ifFalse: [ ^ self ].
	self session logged: true.
	self component gotoAdministration.! !

WAComponent subclass: #TBXCategoriesComponent
	instanceVariableNames: 'categories postsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Components'!

!TBXCategoriesComponent commentStamp: 'PeterPesch 7/3/2020 11:05' prior: 0!
I show the list of all Categories for this tiny Blog Web Aplication.
!

!TBXCategoriesComponent class methodsFor: 'creation' stamp: 'PeterPesch 6/29/2020 13:42'!
categories: aCollectionOfCategories postsList: aTBScreen
	^ self new
		categories: aCollectionOfCategories;
		postsList: aTBScreen! !

!TBXCategoriesComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:34'!
categories
	^ categories! !

!TBXCategoriesComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:34'!
categories: aCollection
	categories := aCollection! !

!TBXCategoriesComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:34'!
postsList
	^ postsList! !

!TBXCategoriesComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:34'!
postsList: aComponent
	postsList := aComponent! !

!TBXCategoriesComponent methodsFor: 'rendering' stamp: 'PeterPesch 6/29/2020 12:58'!
renderCategoryLinkOn: html with: aCategory
	html tbsLinkifyListGroupItem
		class: 'active' if: aCategory = self postsList currentCategory;
		callback: [ self selectCategory: aCategory ];
		with: aCategory! !

!TBXCategoriesComponent methodsFor: 'rendering' stamp: 'PeterPesch 6/29/2020 12:43'!
renderContentOn: html
	html tbsListGroup: [
		html tbsListGroupItem with: [ html strong: 'Categories' ].
		categories do: [ :cat | self renderCategoryLinkOn: html with: cat ] ]! !

!TBXCategoriesComponent methodsFor: 'action' stamp: 'PeterPesch 6/29/2020 12:37'!
selectCategory: aCategory
	postsList currentCategory: aCategory! !

WAComponent subclass: #TBXHeaderComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Components'!

!TBXHeaderComponent commentStamp: 'PeterPesch 7/3/2020 11:05' prior: 0!
I am a component to appear at the top of alls components in our Web App.
!

!TBXHeaderComponent methodsFor: 'rendering' stamp: 'PeterPesch 6/29/2020 12:01'!
renderContentOn: html
	html tbsNavbar beDefault with: [
	html tbsNavbarBrand
	url: '#';
	with: 'TinyBlog' ]! !

WAComponent subclass: #TBXPostComponent
	instanceVariableNames: 'post'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Components'!

!TBXPostComponent commentStamp: 'PeterPesch 7/3/2020 11:05' prior: 0!
I am a Screen Components which shows the Title, Date and Contents of a post.
!

!TBXPostComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:22'!
date
	^ post date! !

!TBXPostComponent methodsFor: 'initialization' stamp: 'PeterPesch 6/29/2020 12:22'!
initialize
super initialize.
post := TBXPost new.! !

!TBXPostComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:26'!
post: aPost
	post := aPost! !

!TBXPostComponent methodsFor: 'rendering' stamp: 'PeterPesch 6/29/2020 12:23'!
renderContentOn: html
	html heading level: 2; with: self title.
	html heading level: 6; with: self date.
	html text: self text! !

!TBXPostComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:22'!
text
	^ post text! !

!TBXPostComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:22'!
title
	^ post title! !

WAComponent subclass: #TBXScreenComponent
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Components'!

!TBXScreenComponent commentStamp: 'PeterPesch 7/3/2020 11:05' prior: 0!
I am an abstract class, to share behaviour between all our components.
!

TBXScreenComponent subclass: #TBXAdminComponent
	instanceVariableNames: 'report'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Components'!

!TBXAdminComponent commentStamp: 'PeterPesch 7/3/2020 13:56' prior: 0!
I am an admin report which contains all posts.!

!TBXAdminComponent methodsFor: 'hooks' stamp: 'PeterPesch 7/3/2020 14:46'!
children
	^ super children copyWith: self report! !

!TBXAdminComponent methodsFor: 'initialization' stamp: 'PeterPesch 7/3/2020 14:47'!
initialize
	super initialize.
	self report: (TBXPostsReport from: self blog)! !

!TBXAdminComponent methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 16:06'!
renderContentOn: html
	"Placeholder for the real rendering ..."
	super renderContentOn: html.
	html tbsContainer: [
		html heading: 'Blog Admin'.
		html tbsGlyphIcon perform: #iconEyeOpen.
		html anchor
			callback: [ self answer ];
			with: 'Public Area'.
		html horizontalRule.
		html render: self report ]! !

!TBXAdminComponent methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 14:40'!
report
	^ report! !

!TBXAdminComponent methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 14:41'!
report: aReport
	report := aReport! !

TBXScreenComponent subclass: #TBXPostsListComponent
	instanceVariableNames: 'currentCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Components'!

!TBXPostsListComponent commentStamp: 'PeterPesch 7/3/2020 11:05' prior: 0!
I am a Screen Components which lists posts from the blog.
!

!TBXPostsListComponent methodsFor: 'rendering' stamp: 'PeterPesch 6/29/2020 14:17'!
categoriesColumnOn: html
 	| categories |   
	categories := OrderedCollection with: 'All'.
	categories addAll: self blog allCategories.
	html render:
        (TBXCategoriesComponent
            categories: categories
            postsList: self)! !

!TBXPostsListComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:39'!
currentCategory
	^ currentCategory! !

!TBXPostsListComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 12:39'!
currentCategory: anObject
	currentCategory := anObject! !

!TBXPostsListComponent methodsFor: 'actions' stamp: 'PeterPesch 7/3/2020 14:18'!
gotoAdministration
	self call: TBXAdminComponent new! !

!TBXPostsListComponent methodsFor: 'rendering' stamp: 'PeterPesch 6/29/2020 13:32'!
postsColumnOn: html
    self readSelectedPosts do: [ :p |
        html render: (TBXPostComponent new post: p) ]! !

!TBXPostsListComponent methodsFor: 'accessing' stamp: 'PeterPesch 6/29/2020 14:20'!
readSelectedPosts
	^ self currentCategory
		ifNil: [ self blog allVisibleBlogPosts ]
		ifNotNil: [ 
			self currentCategory = 'All'
				ifTrue: [ self blog allVisibleBlogPosts ]
				ifFalse: [ self blog allVisibleBlogPostsFromCategory: self currentCategory ] ]! !

!TBXPostsListComponent methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 13:56'!
renderContentOn: html
    super renderContentOn: html.
    html render: (TBXAuthentificationComponent from: self).
    html tbsContainer: [
        html tbsRow
            showGrid;
            with: [ self responsiveColumnsOn: html ]
    ]
! !

!TBXPostsListComponent methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 16:12'!
renderSignInOn: html
	self session isLogged
		ifFalse: [
			html tbsGlyphIcon perform: #iconLock.
         html html: '<a data-toggle="modal" href="#myAuthDialog" class="link">SignIn</a>' ]
		ifTrue: [ 
			html tbsGlyphIcon perform: #iconUser.
         html anchor
				callback: [ self gotoAdministration ];
				with: 'Private area' ]

! !

!TBXPostsListComponent methodsFor: 'rendering' stamp: 'PeterPesch 7/3/2020 12:14'!
responsiveColumnsOn: html
    html tbsColumn
        extraSmallSize: 12;
        smallSize: 2;
        mediumSize: 4;
        with: [ self categoriesColumnOn: html.
	             self renderSignInOn: html ].
    html tbsColumn
        extraSmallSize: 12;
        smallSize: 10;
        mediumSize: 8;
        with: [ self postsColumnOn: html ] 
! !

!TBXScreenComponent methodsFor: 'acccessing' stamp: 'PeterPesch 6/29/2020 11:50'!
blog
	"Return the current blog.
	In the future we will ask the session to return the blog of the currently logged user."
	^ TBXBlog current! !

!TBXScreenComponent methodsFor: 'hooks' stamp: 'PeterPesch 6/29/2020 12:04'!
children
	^ OrderedCollection with: header! !

!TBXScreenComponent methodsFor: 'initialization' stamp: 'PeterPesch 6/29/2020 12:02'!
initialize
	super initialize.
	header := TBXHeaderComponent new.! !

!TBXScreenComponent methodsFor: 'rendering' stamp: 'PeterPesch 6/29/2020 12:05'!
renderContentOn: html
	html render: header! !

!XMLNode methodsFor: '*TinyBlog' stamp: 'PeterPesch 6/24/2020 12:23'!
allElements: tagname
    "Return all descendant nodes with given tagname"
    | result |
    result := OrderedCollection new.
    self elementName = tagname ifTrue: [ result add: self ].
    self children do: [ :child | result addAll: (child allElements: tagname) ].
    ^ result.! !

!XMLNode methodsFor: '*TinyBlog' stamp: 'PeterPesch 6/23/2020 17:00'!
children
    "Return the children of this XMLNode."
    self hasChildren
        ifTrue: [ ^ self nodes collection ]
        ifFalse: [ ^ OrderedCollection new ]! !

!XMLNode methodsFor: '*TinyBlog' stamp: 'PeterPesch 6/23/2020 16:58'!
elementName 
    "Return the name of this XMLNode, if it is an element."
    self isElement
        ifTrue: [ ^ self name ]
        ifFalse: [ ^ '' ]! !

WASession subclass: #TBXSession
	instanceVariableNames: 'logged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Components'!

!TBXSession commentStamp: 'PeterPesch 7/3/2020 16:08' prior: 0!
I represent a Session in the Web App.!

!TBXSession methodsFor: 'initialization' stamp: 'PeterPesch 7/3/2020 16:05'!
initialize
	super initialize.
	self logged: false.! !

!TBXSession methodsFor: 'testing' stamp: 'PeterPesch 7/3/2020 16:04'!
isLogged
	^ self logged! !

!TBXSession methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 16:04'!
logged
	^ logged! !

!TBXSession methodsFor: 'accessing' stamp: 'PeterPesch 7/3/2020 16:04'!
logged: anObject
	logged := anObject! !

Object subclass: #TBXBlog
	instanceVariableNames: 'posts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Core'!

!TBXBlog commentStamp: 'PeterPesch 6/19/2020 12:29' prior: 0!
I represent a Tiny Blog.

I can show Posts from different Categories.

Peter Pesch, based on the code from the Pharo Mooc.
!

!TBXBlog class methodsFor: 'action' stamp: 'PeterPesch 6/12/2020 15:38'!
createDemoPosts
    "TBBlog createDemoPosts"
    self current
    writeBlogPost: ((TBXPost
        title: 'Welcome in TinyBlog'
        text: 'TinyBlog is a small blog engine made with Pharo.'
        category: 'TinyBlog') visible: true);
    writeBlogPost: ((TBXPost
        title: 'Report Pharo Sprint'
        text: 'Friday, June 12 there was a Pharo sprint / Moose dojo. It was a
nice event with more than 15 motivated sprinters. With the help
of candies, cakes and chocolate, huge work has been done'
        category: 'Pharo') visible: true);
    writeBlogPost: ((TBXPost
        title: 'Brick on top of Bloc - Preview'
        text: 'We are happy to announce the first previewversion of Brick, a new widget set created from scratch on top of Bloc. Brick is being developed primarily by Alex Syrel (together with Alain Plantec, Andrei Chis and myself), and the work is sponsored by ESUG.
Brick is part of the Glamorous Toolkit effort and will provide the basis for the new versions of the development tools.'
        category: 'Pharo') visible: true);
    writeBlogPost: ((TBXPost
        title: 'The sad story of unclassified blog posts'
        text: 'So sad that I can read this.') visible: true);
    writeBlogPost: ((TBXPost
        title: 'Working with Pharo on the Raspberry Pi'
        text: 'Hardware is getting cheaper and many new small devices like the famous Raspberry Pi provide new computation power that was one once only available on regular desktop computers.'
        category: 'Pharo') visible: true)! !

!TBXBlog class methodsFor: 'accessing' stamp: 'PeterPesch 6/26/2020 14:16'!
current
	"Return the singleton instance."
	^ self selectAll
		ifNotEmpty: [ :x | x anyOne ]
		ifEmpty: [ self new save ]
! !

!TBXBlog class methodsFor: 'class initialization' stamp: 'PeterPesch 6/18/2020 17:53'!
initialize
	self reset! !

TBXBlog initialize!

!TBXBlog class methodsFor: 'initialization' stamp: 'PeterPesch 6/26/2020 16:41'!
initializeLocalhostMongoDB
	| repository |
	repository := VOMongoRepository database: 'tinyblog'.
	repository enableSingleton.
! !

!TBXBlog class methodsFor: 'initialization' stamp: 'PeterPesch 6/26/2020 14:09'!
initializeVoyageOnMemoryDB
	VOMemoryRepository new enableSingleton! !

!TBXBlog class methodsFor: 'testing' stamp: 'PeterPesch 6/26/2020 14:02'!
isVoyageRoot
	"Indicates that instances of this class are top level document in noSQL databases"
	^ true
! !

!TBXBlog class methodsFor: 'action' stamp: 'PeterPesch 6/26/2020 16:41'!
reset
	self initializeLocalhostMongoDB! !

!TBXBlog methodsFor: 'accessing' stamp: 'PeterPesch 6/12/2020 15:01'!
allBlogPosts
	^ posts
! !

!TBXBlog methodsFor: 'accessing' stamp: 'PeterPesch 6/18/2020 17:50'!
allBlogPostsFromCategory: aCategory
	^ posts select: [ :post | post category = aCategory  ]! !

!TBXBlog methodsFor: 'accessing' stamp: 'PeterPesch 6/12/2020 15:24'!
allCategories
	^ (self allBlogPosts collect: [ :p | p category ]) asSet! !

!TBXBlog methodsFor: 'accessing' stamp: 'PeterPesch 6/19/2020 12:33'!
allVisibleBlogPosts
	^ posts select: #isVisible! !

!TBXBlog methodsFor: 'accessing' stamp: 'PeterPesch 6/12/2020 15:15'!
allVisibleBlogPostsFromCategory: aCategory 
	^ posts select: [ :post | post isVisible and: [ post category = aCategory ] ]! !

!TBXBlog methodsFor: 'initialization' stamp: 'PeterPesch 6/12/2020 14:56'!
initialize
	super initialize.
	posts := OrderedCollection new! !

!TBXBlog methodsFor: 'testing' stamp: 'PeterPesch 7/4/2020 20:08'!
isEmpty
	^ posts isEmpty! !

!TBXBlog methodsFor: 'action' stamp: 'PeterPesch 6/26/2020 17:40'!
removeAllPosts
	"posts := OrderedCollection new."
	self allBlogPosts
		removeAll;
		compact.
	self save! !

!TBXBlog methodsFor: 'removing' stamp: 'PeterPesch 7/3/2020 15:28'!
removeBlogPost: aPost
	posts remove: aPost ifAbsent: [ ].
	self save! !

!TBXBlog methodsFor: 'removing' stamp: 'PeterPesch 6/29/2020 10:21'!
removeLast
	posts removeLast.
	self save.
! !

!TBXBlog methodsFor: 'removing' stamp: 'PeterPesch 7/4/2020 20:11'!
removeLast: anInteger
	posts removeLast: anInteger.
	self save.
! !

!TBXBlog methodsFor: 'accessing' stamp: 'PeterPesch 6/12/2020 14:40'!
size
	^ posts size! !

!TBXBlog methodsFor: 'action' stamp: 'PeterPesch 6/26/2020 14:36'!
writeBlogPost: aPost
	"Add the blog post to the blog."
	self allBlogPosts add: aPost.
	self save! !

Object subclass: #TBXPost
	instanceVariableNames: 'title text date category visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TinyBlog-Core'!

!TBXPost commentStamp: 'PeterPesch 6/19/2020 12:30' prior: 0!
I represent a Post on the Tiny Blog.

I have a tilte, text, date and category, and I may be visible.

Peter Pesch, based on the code from the Pharo Mooc.!

!TBXPost class methodsFor: 'instance creation' stamp: 'PeterPesch 6/10/2020 16:48'!
title: aTitle text: aText
	"Create a new text in the Unclassified category."

	^ self new
		title: aTitle;
		text: aText;
		yourself! !

!TBXPost class methodsFor: 'instance creation' stamp: 'PeterPesch 6/10/2020 16:48'!
title: aTitle text: aText category: aCategory
	"Create a new text in a given category."

	^ (self title: aTitle text: aText)
		category: aCategory;
		yourself! !

!TBXPost class methodsFor: 'classification' stamp: 'PeterPesch 6/10/2020 16:38'!
unclassifiedTag
	"Unclassified Category"
			
	^ 'Unclassified'! !

!TBXPost methodsFor: 'action' stamp: 'PeterPesch 6/10/2020 16:30'!
beVisible
	"Make the post visible"
			
	self visible: true! !

!TBXPost methodsFor: 'accessing' stamp: 'PeterPesch 6/10/2020 16:23'!
category
	"Return the name of the category of the post"

	^ category! !

!TBXPost methodsFor: 'accessing' stamp: 'PeterPesch 6/10/2020 16:28'!
category: anObject
	"Updates the name of the category of the post"

	category := anObject ! !

!TBXPost methodsFor: 'accessing' stamp: 'PeterPesch 6/10/2020 16:22'!
date
	"Return the date of writing"

	^ date! !

!TBXPost methodsFor: 'accessing' stamp: 'PeterPesch 6/10/2020 16:27'!
date: aDate
	"Updates the date of writing"

	date := aDate! !

!TBXPost methodsFor: 'accessing-magritte' stamp: 'PeterPesch 7/3/2020 15:56'!
descriptionCategory
	<magritteDescription>
	^ MAStringDescription new
		label: 'Category';
		priority: 300;
		accessor: #category;
		comment: 'Unclassified if empty';
		componentClass: TBSMagritteTextInputComponent;
		yourself! !

!TBXPost methodsFor: 'accessing-magritte' stamp: 'PeterPesch 7/3/2020 15:52'!
descriptionContainer
	<magritteContainer>
	^ super descriptionContainer
		componentRenderer: TBSMagritteFormRenderer;
		yourself! !

!TBXPost methodsFor: 'accessing-magritte' stamp: 'PeterPesch 7/3/2020 14:54'!
descriptionDate
	<magritteDescription>
	^ MADateDescription new
		label: ' Date';
		priority: 400;
		accessor: #date;
		beRequired;
		yourself! !

!TBXPost methodsFor: 'accessing-magritte' stamp: 'PeterPesch 7/3/2020 15:55'!
descriptionText
	<magritteDescription>
	^ MAMemoDescription new
		label: ' Text';
		priority: 200;
		accessor: #text;
		beRequired;
		requiredErrorMessage: 'A blog post must contain a text.';
		comment: 'Please enter a text';
		componentClass: TBSMagritteTextAreaComponent;
		yourself! !

!TBXPost methodsFor: 'accessing-magritte' stamp: 'PeterPesch 7/3/2020 15:55'!
descriptionTitle
	<magritteDescription>
	^ MAStringDescription new
		label: 'Title';
		priority: 100;
		accessor: #title;
		requiredErrorMessage: 'A blog post must have a title.';
		comment: 'Please enter a title';
		componentClass: TBSMagritteTextInputComponent;
		beRequired;
		yourself! !

!TBXPost methodsFor: 'accessing-magritte' stamp: 'PeterPesch 7/3/2020 15:56'!
descriptionVisible
	<magritteDescription>
	^ MABooleanDescription new
		label: 'Visible';
		priority: 50;
		accessor: #visible;
		componentClass: TBSMagritteCheckboxComponent;
		beRequired;
		yourself! !

!TBXPost methodsFor: 'initialization' stamp: 'PeterPesch 7/3/2020 16:30'!
initialize
	"Intialize ta new post as Unclassified"	

	super initialize.
	self category: self class unclassifiedTag.
	self date: Date today asDate.
	self notVisible! !

!TBXPost methodsFor: 'testing' stamp: 'PeterPesch 6/10/2020 17:16'!
isUnclassified
	"Check whether post is in Unclassified category"	

	^ self category = self class unclassifiedTag! !

!TBXPost methodsFor: 'testing' stamp: 'PeterPesch 6/10/2020 17:14'!
isVisible
	"Check whether post is visible"	

	^ self visible! !

!TBXPost methodsFor: 'action' stamp: 'PeterPesch 6/10/2020 16:31'!
notVisible
	"Hide the post"

	self visible: false! !

!TBXPost methodsFor: 'accessing' stamp: 'PeterPesch 6/10/2020 16:22'!
text
	"Return the post text"
			
	^ text! !

!TBXPost methodsFor: 'accessing' stamp: 'PeterPesch 6/10/2020 16:26'!
text: aString
	"Updates the post text"

	text := aString ! !

!TBXPost methodsFor: 'accessing' stamp: 'PeterPesch 6/10/2020 16:21'!
title
	"Return the post title"
			
	^ title! !

!TBXPost methodsFor: 'accessing' stamp: 'PeterPesch 6/10/2020 16:25'!
title: aString
	"Updates the post title"

	title := aString ! !

!TBXPost methodsFor: 'accessing' stamp: 'PeterPesch 6/10/2020 16:24'!
visible
	"Return whether the post is visible or not"

	^ visible! !

!TBXPost methodsFor: 'accessing' stamp: 'PeterPesch 6/10/2020 16:25'!
visible: aBoolean
	"Updates whether the post is visible or not"

	visible := aBoolean ! !

Object subclass: #TBXTeapotWebApp
	instanceVariableNames: 'teapot'
	classVariableNames: 'Server'
	poolDictionaries: ''
	category: 'TinyBlog-Teapot'!

!TBXTeapotWebApp commentStamp: 'PeterPesch 6/19/2020 12:50' prior: 0!
I represent a simple Web Interface for the Tiny Blog.

I access the TinyBlog API and I use the Teaport Web Platform.

Peter Pesch, based on the code from the Pharo Mooc.!

!TBXTeapotWebApp class methodsFor: 'instance creation' stamp: 'PeterPesch 6/24/2020 14:32'!
singleton
	Server ifNil: [ Server := self new start ].
	^ Server! !

!TBXTeapotWebApp class methodsFor: 'controlling' stamp: 'PeterPesch 6/24/2020 14:16'!
start
    Server ifNil: [ Server := self new start ]! !

!TBXTeapotWebApp class methodsFor: 'controlling' stamp: 'PeterPesch 6/24/2020 14:16'!
stop
    Server ifNotNil: [ :arg | Server stop. Server := nil ]! !

!TBXTeapotWebApp methodsFor: 'contents' stamp: 'PeterPesch 6/19/2020 15:45'!
allPosts
    ^ TBXBlog current allVisibleBlogPosts! !

!TBXTeapotWebApp methodsFor: 'rendering' stamp: 'PeterPesch 6/24/2020 14:42'!
errorPage
	^ String streamContents: [ :s |
		self renderPageHeaderOn: s.
		s << '<p>Oops, an error occurred</p>'.
		self renderPageFooterOn: s ]! !

!TBXTeapotWebApp methodsFor: 'contents' stamp: 'PeterPesch 6/24/2020 15:21'!
homePage
    ^ String streamContents: [ :s |
        self renderPageHeaderOn: s.
        s << '<h1>TinyBlog Web App</h1>'.
        s << '<ul>'.
        self allPosts withIndexDo: [ :aPost :index |
            s << '<li>';
            << ('<a href="/post/', index asString, '">');
            << aPost title ;
            << '</a></li>' ].
        s << '</ul>'.
        self renderPageFooterOn: s ]! !

!TBXTeapotWebApp methodsFor: 'initialization' stamp: 'PeterPesch 7/4/2020 19:52'!
initialize
    super initialize.
    teapot := Teapot configure: {
        #port -> 8081.
        #debugMode -> true }
! !

!TBXTeapotWebApp methodsFor: 'testing' stamp: 'PeterPesch 7/4/2020 19:53'!
isRunning
	^ teapot server isRunning.! !

!TBXTeapotWebApp methodsFor: 'contents' stamp: 'PeterPesch 7/5/2020 09:01'!
pageForPostNumber: aPostNumber
	| currentPost |
	currentPost := self allPosts at: aPostNumber ifAbsent: [ ^ self errorPage ].
	^ String streamContents: [ :s |
		self renderPageHeaderOn: s.
		s << ('<h1>', currentPost title, '</h1>').
		s << ('<h3>', currentPost date asDate mmddyyyy, '</h3>').
		s << ('<p> Category: ', currentPost category, '</p>').
		s << ('<p>', currentPost text, '</p>').
		self renderPageFooterOn: s ]! !

!TBXTeapotWebApp methodsFor: 'rendering' stamp: 'PeterPesch 6/19/2020 15:48'!
renderPageFooterOn: aStream
    aStream << '</body></html>'! !

!TBXTeapotWebApp methodsFor: 'rendering' stamp: 'PeterPesch 6/19/2020 15:48'!
renderPageHeaderOn: aStream
    aStream << '<html><body>'! !

!TBXTeapotWebApp methodsFor: 'controlling' stamp: 'PeterPesch 7/4/2020 19:51'!
start
    teapot
        GET: '/' -> [ self homePage ];
        GET: '/post/<id>' -> [ :request | self pageForPostNumber: (request at: #id) asNumber ];
        start! !

!TBXTeapotWebApp methodsFor: 'controlling' stamp: 'PeterPesch 7/4/2020 19:52'!
stop
    teapot stop! !

TBXBlog initialize!

TBXApplicationRootComponent initialize!
